# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from handeye/CalibrateHandEyeRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class CalibrateHandEyeRequest(genpy.Message):
  _md5sum = "9452c7113df2fa7160fa51c55eef0fd7"
  _type = "handeye/CalibrateHandEyeRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """string                    setup
string                    solver
geometry_msgs/PoseArray   effector_wrt_world
geometry_msgs/PoseArray   object_wrt_sensor

================================================================================
MSG: geometry_msgs/PoseArray
# An array of poses with a header for global reference.

Header header

Pose[] poses

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['setup','solver','effector_wrt_world','object_wrt_sensor']
  _slot_types = ['string','string','geometry_msgs/PoseArray','geometry_msgs/PoseArray']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       setup,solver,effector_wrt_world,object_wrt_sensor

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CalibrateHandEyeRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.setup is None:
        self.setup = ''
      if self.solver is None:
        self.solver = ''
      if self.effector_wrt_world is None:
        self.effector_wrt_world = geometry_msgs.msg.PoseArray()
      if self.object_wrt_sensor is None:
        self.object_wrt_sensor = geometry_msgs.msg.PoseArray()
    else:
      self.setup = ''
      self.solver = ''
      self.effector_wrt_world = geometry_msgs.msg.PoseArray()
      self.object_wrt_sensor = geometry_msgs.msg.PoseArray()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.setup
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.solver
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3I().pack(_x.effector_wrt_world.header.seq, _x.effector_wrt_world.header.stamp.secs, _x.effector_wrt_world.header.stamp.nsecs))
      _x = self.effector_wrt_world.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.effector_wrt_world.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.effector_wrt_world.poses:
        _v1 = val1.position
        _x = _v1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v2 = val1.orientation
        _x = _v2
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_get_struct_3I().pack(_x.object_wrt_sensor.header.seq, _x.object_wrt_sensor.header.stamp.secs, _x.object_wrt_sensor.header.stamp.nsecs))
      _x = self.object_wrt_sensor.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.object_wrt_sensor.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.object_wrt_sensor.poses:
        _v3 = val1.position
        _x = _v3
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v4 = val1.orientation
        _x = _v4
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.effector_wrt_world is None:
        self.effector_wrt_world = geometry_msgs.msg.PoseArray()
      if self.object_wrt_sensor is None:
        self.object_wrt_sensor = geometry_msgs.msg.PoseArray()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.setup = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.setup = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.solver = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.solver = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.effector_wrt_world.header.seq, _x.effector_wrt_world.header.stamp.secs, _x.effector_wrt_world.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.effector_wrt_world.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.effector_wrt_world.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.effector_wrt_world.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Pose()
        _v5 = val1.position
        _x = _v5
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v6 = val1.orientation
        _x = _v6
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.effector_wrt_world.poses.append(val1)
      _x = self
      start = end
      end += 12
      (_x.object_wrt_sensor.header.seq, _x.object_wrt_sensor.header.stamp.secs, _x.object_wrt_sensor.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.object_wrt_sensor.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.object_wrt_sensor.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object_wrt_sensor.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Pose()
        _v7 = val1.position
        _x = _v7
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v8 = val1.orientation
        _x = _v8
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.object_wrt_sensor.poses.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.setup
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.solver
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3I().pack(_x.effector_wrt_world.header.seq, _x.effector_wrt_world.header.stamp.secs, _x.effector_wrt_world.header.stamp.nsecs))
      _x = self.effector_wrt_world.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.effector_wrt_world.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.effector_wrt_world.poses:
        _v9 = val1.position
        _x = _v9
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v10 = val1.orientation
        _x = _v10
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_get_struct_3I().pack(_x.object_wrt_sensor.header.seq, _x.object_wrt_sensor.header.stamp.secs, _x.object_wrt_sensor.header.stamp.nsecs))
      _x = self.object_wrt_sensor.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.object_wrt_sensor.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.object_wrt_sensor.poses:
        _v11 = val1.position
        _x = _v11
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v12 = val1.orientation
        _x = _v12
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.effector_wrt_world is None:
        self.effector_wrt_world = geometry_msgs.msg.PoseArray()
      if self.object_wrt_sensor is None:
        self.object_wrt_sensor = geometry_msgs.msg.PoseArray()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.setup = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.setup = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.solver = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.solver = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.effector_wrt_world.header.seq, _x.effector_wrt_world.header.stamp.secs, _x.effector_wrt_world.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.effector_wrt_world.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.effector_wrt_world.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.effector_wrt_world.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Pose()
        _v13 = val1.position
        _x = _v13
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v14 = val1.orientation
        _x = _v14
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.effector_wrt_world.poses.append(val1)
      _x = self
      start = end
      end += 12
      (_x.object_wrt_sensor.header.seq, _x.object_wrt_sensor.header.stamp.secs, _x.object_wrt_sensor.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.object_wrt_sensor.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.object_wrt_sensor.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object_wrt_sensor.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Pose()
        _v15 = val1.position
        _x = _v15
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v16 = val1.orientation
        _x = _v16
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.object_wrt_sensor.poses.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from handeye/CalibrateHandEyeResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class CalibrateHandEyeResponse(genpy.Message):
  _md5sum = "a500c4ad906c1d8c5f99d37687460c1f"
  _type = "handeye/CalibrateHandEyeResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """bool                      success
# For a Moving setup, sensor_frame contains:
# The estimated pose between the sensor and the robot end-effector
# For a Fixed setup, sensor_frame contains:
# The estimated pose between the sensor and the world
geometry_msgs/Pose        sensor_frame
float64                   rotation_rmse
float64                   translation_rmse


================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['success','sensor_frame','rotation_rmse','translation_rmse']
  _slot_types = ['bool','geometry_msgs/Pose','float64','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       success,sensor_frame,rotation_rmse,translation_rmse

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CalibrateHandEyeResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.success is None:
        self.success = False
      if self.sensor_frame is None:
        self.sensor_frame = geometry_msgs.msg.Pose()
      if self.rotation_rmse is None:
        self.rotation_rmse = 0.
      if self.translation_rmse is None:
        self.translation_rmse = 0.
    else:
      self.success = False
      self.sensor_frame = geometry_msgs.msg.Pose()
      self.rotation_rmse = 0.
      self.translation_rmse = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_B9d().pack(_x.success, _x.sensor_frame.position.x, _x.sensor_frame.position.y, _x.sensor_frame.position.z, _x.sensor_frame.orientation.x, _x.sensor_frame.orientation.y, _x.sensor_frame.orientation.z, _x.sensor_frame.orientation.w, _x.rotation_rmse, _x.translation_rmse))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.sensor_frame is None:
        self.sensor_frame = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 73
      (_x.success, _x.sensor_frame.position.x, _x.sensor_frame.position.y, _x.sensor_frame.position.z, _x.sensor_frame.orientation.x, _x.sensor_frame.orientation.y, _x.sensor_frame.orientation.z, _x.sensor_frame.orientation.w, _x.rotation_rmse, _x.translation_rmse,) = _get_struct_B9d().unpack(str[start:end])
      self.success = bool(self.success)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_B9d().pack(_x.success, _x.sensor_frame.position.x, _x.sensor_frame.position.y, _x.sensor_frame.position.z, _x.sensor_frame.orientation.x, _x.sensor_frame.orientation.y, _x.sensor_frame.orientation.z, _x.sensor_frame.orientation.w, _x.rotation_rmse, _x.translation_rmse))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.sensor_frame is None:
        self.sensor_frame = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 73
      (_x.success, _x.sensor_frame.position.x, _x.sensor_frame.position.y, _x.sensor_frame.position.z, _x.sensor_frame.orientation.x, _x.sensor_frame.orientation.y, _x.sensor_frame.orientation.z, _x.sensor_frame.orientation.w, _x.rotation_rmse, _x.translation_rmse,) = _get_struct_B9d().unpack(str[start:end])
      self.success = bool(self.success)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B9d = None
def _get_struct_B9d():
    global _struct_B9d
    if _struct_B9d is None:
        _struct_B9d = struct.Struct("<B9d")
    return _struct_B9d
class CalibrateHandEye(object):
  _type          = 'handeye/CalibrateHandEye'
  _md5sum = '04f81db812e7be5af7dacdfd384d6a48'
  _request_class  = CalibrateHandEyeRequest
  _response_class = CalibrateHandEyeResponse
